import Bladex
import EnemyTypes
import Enm_Def
import Reference
import AniSound
import Sounds
import Combat
import copy
import Actions
import GameStateAux
import Language
import GenFX
import Breakings
import Damage
import netgame
import B3DLib
import BCopy
import InitDataField
import Objects
import whrandom
import math
import AuxFuncs
import CharStats
import pdb

MESSAGE_START_WEAPON         =7
MESSAGE_STOP_WEAPON          =8

TRUE = 1
FALSE = 0

#########################
####   DYING DWARF   ####
#########################

class DrunkWarder(Enm_Def.NPCPerson):

	Durmiendo=0
	Murmurando=0
	Molestado=0
	Muerto=0
	ronquidos=None
	habladormido=None
	molestia=None
	muerte=None

	def __init__(self, person):
		Enm_Def.NPCPerson.__init__(self, person)
		self.Durmiendo=0
		self.Murmurando=0
		self.Molestado=0
		self.Muerto=0
		person.SetTmpAnmFlags(1, 1, 0, 0, 1, 1, 0)
		person.LaunchAnimation("Tkn_sleep2")
		person.SetOnFloor()

		self.ronquidos=Bladex.CreateSound("..\\..\\Sounds\\traidor-respira2.wav", "Ronquidos")
		self.ronquidos.Volume=1
		self.ronquidos.Scale=0.3
		self.ronquidos.MinDistance= 5000
		self.ronquidos.MaxDistance=15000

		self.habladormido=Bladex.CreateSound("..\\..\\Sounds\\traidor-respira.wav", "HablaDormido")
		self.habladormido.Volume=1
		self.habladormido.Scale=0.3
		self.habladormido.MinDistance= 5000
		self.habladormido.MaxDistance=50000

		self.molestia=Bladex.CreateSound("..\\..\\Sounds\\muerteTkn3.wav", "Molestia")
		self.molestia.Volume=1
		self.molestia.Scale=0.3
		self.molestia.MinDistance= 5000
		self.molestia.MaxDistance=25000

		self.muerte=Bladex.CreateSound("..\\..\\Sounds\\muerteTkn2.wav", "Muerte")
		self.muerte.Volume=1
		self.muerte.Scale=1.0
		self.muerte.MinDistance= 5000
		self.muerte.MaxDistance=15000

	def Murmura(self, entity_name):
		print "Murmura..."
		self.Murmurando=1
		if self.Durmiendo:
			self.Durmiendo=0
			self.ronquidos.Stop()
		if self.Molestado:
			self.Molestado=0
			self.molestia.Stop()
		person=Bladex.GetEntity(entity_name)
		person.Wuea=Reference.WUEA_ENDED
		person.LaunchAnimation("Tkn_sleep")
		person.SetOnFloor()
		self.habladormido.Play(person.Position[0], person.Position[1], person.Position[2], 0)
		person.AnmEndedFunc=self.Duerme

	def Duerme(self, entity_name):
		print "Duerme..."
		if self.Muerto:
			return
		self.Durmiendo=1
		if self.Murmurando:
			self.Murmurando=0
		if self.Molestado:
			self.Molestado=0
		person=Bladex.GetEntity(entity_name)
		person.Wuea=Reference.WUEA_ENDED
		person.SetTmpAnmFlags(1, 1, 0, 0, 1, 1, 0)
		person.LaunchAnimation("Tkn_sleep2")
		person.SetOnFloor()
		self.ronquidos.Play(person.Position[0], person.Position[1], person.Position[2], -1)

	def Molestia(self, entity_name):
		print "Se molesta..."
		self.Molestado=1
		if self.Durmiendo:
			self.Durmiendo=0
			self.ronquidos.Stop()
		if self.Murmurando:
			self.Murmurando=0
			self.habladormido.Stop()
		person=Bladex.GetEntity(entity_name)
		person.Wuea=Reference.WUEA_ENDED
		person.LaunchAnimation("Tkn_sleep_hit")
		person.SetOnFloor()
		self.molestia.Play(person.Position[0], person.Position[1], person.Position[2], 0)
		person.AnmEndedFunc=self.Duerme

	def Muere(self, entity_name):
		print "Muere..."
		if self.Durmiendo:
			self.Durmiendo=0
			self.ronquidos.Stop()
		if self.Murmurando:
			self.Murmurando=0
			self.habladormido.Stop()
		if self.Molestado:
			self.Molestado=0
			self.molestia.Stop()
		person=Bladex.GetEntity(entity_name)
		person.Wuea=Reference.WUEA_ENDED
		person.LaunchAnimation("Tkn_dth_sleep")
		person.SetOnFloor()
		self.muerte.Play(person.Position[0], person.Position[1], person.Position[2], 0)
		self.Muerto=1

	# Functions for loading and saving state
	def __getstate__(self):
		#print "DrunkWarder.__getstate__"
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			#print "ERROR: DrunkWarder.__getstate__(): Base class version differs."
			return NPCPerson_state
		NPCPerson_state[1]["DrunkWarder"]=(self.ronquidos.Name,self.habladormido.Name,
										   self.molestia.Name,self.muerte.Name,
										   self.Durmiendo,self.Murmurando,self.Molestado,self.Muerto
										  )
		return NPCPerson_state
	
	def __setstate__(self,parm):
		#print "DrunkWarder.__setstate__"
		# Toma como par⮥tro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["DrunkWarder"]
			self.ronquidos=Bladex.GetSound(parms[0])
			self.habladormido=Bladex.GetSound(parms[1])
			self.molestia=Bladex.GetSound(parms[2])
			self.muerte=Bladex.GetSound(parms[3])
			self.Durmiendo=parms[4]
			self.Murmurando=parms[5]
			self.Molestado=parms[6]
			self.Muerto=parms[7]

################ BREAK WALLS ##############################################################################################
class BreakSector:
	def __init__(self):
		self.ObjId=ObjStore.GetNewId() # Para identificarlo al grabar/guardar
		ObjStore.ObjectsStore[self.ObjId]=self
		self.sector=None
		self.sector2=None
		self.break_sound=None
		self.hit_sound=None
		self.polvo = 0
		self.polvo_vel=None
		self.polvo_p0=None
		self.polvo_p1=None
		self.polvo_p2=None
		self.polvo_p3=None
		self.life=None
		self.pos = (0,0,0)
		self.normal = (1,0,0)

	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,
				self.ObjId,
				self.sector,
				self.sector2,
				self.break_sound,
				self.hit_sound,
				self.polvo,
				self.polvo_vel,
				self.polvo_p0,
				self.polvo_p1,
				self.polvo_p2,
				self.polvo_p3,
				self.life,
                self.pos,
                self.normal
				)

	def __setstate__(self,parm):
		if parm[0]==1:
			self.ObjId=parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.sector=parm[2]
			self.sector2=parm[3]
			self.break_sound=parm[4]
			self.hit_sound=parm[5]
			self.polvo=parm[6]
			self.polvo_vel=parm[7]
			self.polvo_p0=parm[8]
			self.polvo_p1=parm[9]
			self.polvo_p2=parm[10]
			self.polvo_p3=parm[11]
			self.life=parm[12]
			self.pos=parm[13]
			self.normal=parm[14]
		else:
			print "Version mismatch in BreakSector"
			self.ObjId=ObjStore.GetNewId() # Para identificarlo al grabar/guardar
			ObjStore.ObjectsStore[self.ObjId]=self
			self.sector=None
			self.sector2=None
			self.break_sound=None
			self.hit_sound=None
			self.polvo = 0
			self.polvo_vel=None
			self.polvo_p0=None
			self.polvo_p1=None
			self.polvo_p2=None
			self.polvo_p3=None
			self.life=None
			self.pos = (0,0,0)
			self.normal = (1,0,0)

	def HitSector(self,sector,weapon,ipx,ipy,ipz,ximpulse=0,yimpulse=0,zimpulse=0,x_norm=0,y_norm=0,z_norm=0,material=""):
		self.life = self.life - 1

		if self.life <= 0:
			self.sector.DoBreak(self.normal, (ipx,ipy,ipz), (0.0, 0.0, 0.0))
			self.sector.Active = 1
			self.sector2.OnHit = ""
			self.break_sound.Play(self.pos[0],self.pos[1],self.pos[2],0)		

			if self.polvo:
				self.SetPolvo()
		else:
			self.hit_sound.Play(ipx,ipy,ipz,0)

	def InitBreak(self,pos,pos2,normal,life,dir,dir1,dir2):
		self.sector2 = Bladex.GetSector(pos2[0],pos2[1],pos2[2])
		self.sector = Bladex.GetSector(pos[0],pos[1],pos[2])
		
		self.break_sound=Bladex.CreateSound('..\..\Sounds\\madera-rotura-pesada.wav', 'SonidoDesprendimiento')
		self.break_sound.Volume=1.0
		self.break_sound.MinDistance=3000
		self.break_sound.MaxDistance=40000

		self.hit_sound=Bladex.CreateSound('..\..\Sounds\\golpe-madera-pesada.wav', 'SonidoHit')
		self.hit_sound.Volume=1.0
		self.hit_sound.MinDistance=3000
		self.hit_sound.MaxDistance=40000

		self.sector.InitBreak(dir, dir1, dir2)
		self.sector2.OnHit = self.HitSector		
		self.sector2.ActiveSurface = normal
		self.normal = normal[0] * -6.5,normal[1] * -6.5,normal[2] * -6.5

		self.sector.Active = 0
		self.life = life
		self.pos = pos

	def ActivatePolvo(self,p1,p2,p3,p4,vel):
		self.polvo_vel = vel
		self.polvo_p0 = p1
		self.polvo_p1 = p2
		self.polvo_p2 = p3
		self.polvo_p3 = p4
		self.polvo = 1

	def SetPolvo(self):
		self.polvoTri(self.polvo_p0,self.polvo_p1,self.polvo_p2,self.polvo_vel,"dustA")
		self.polvoTri(self.polvo_p1,self.polvo_p2,self.polvo_p3,self.polvo_vel,"dustB")

	def polvoTri(self,a,b,c,vel,name):
		dust=Bladex.CreateEntity(name, "Entity Particle System D3", a[0],a[1],a[2])
		dust.D1= b[0]-a[0] ,b[1]-a[1] ,b[2]-a[2]
		dust.D2= c[0]-b[0] ,c[1]-b[1] ,c[2]-b[2]
		dust.ParticleType="MediumDust"
		dust.YGravity=230.0
		dust.Friction=0.2
		dust.PPS=1000
		dust.Velocity= vel
		dust.RandomVelocity=20.0
		dust.Time2Live=16
		dust.DeathTime=Bladex.GetTime() + 0.8


####################################################################################################################

#### INTRO STUFF
